// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 7-Aug-1997
// 
#include<LINK/algorithm/Algorithms.h>
#include<LINK/graph/Attribute.h>
#include<LINK/graph/Graph.h>
#include<LINK/layout/Layouts.h>
#include<math.h>
void 
DFSLayout(Graph *g)
{
    Sequence<Vertex*> dfsorder = DepthFirstSearch(g);
    Iterator<Vertex*> get_vert(&dfsorder);
    Vertex *v;
    int dfs_tree, height;
    int max_dfs_tree=0, max_height=0;
    while (get_vert(v)) {
	getAttribute((GraphObject*) v, "type", dfs_tree);
	getAttribute((GraphObject*) v, "distance", height);
	if (dfs_tree > max_dfs_tree)
		max_dfs_tree = dfs_tree;
	if (height > max_height)
		max_height = height;
    }
    get_vert.reset();
     
    const double 	top = 0.9;
    const double	bottom = 0.1;
    const double	x_inc = (top-bottom)/(max_dfs_tree+2);
    const double	y_inc = (top-bottom)/(max_height+2); 
    int order = g->order();
    double x, y;
    
    const SortedArray<Vertex*> vgs = g->vertices(); 
    y = top;
    int i, j;
    while (get_vert(v)) {
	getAttribute((GraphObject*) v, "distance", i);
	getAttribute((GraphObject*) v, "type", j);
        y = top - (i+1)*y_inc;
        x = bottom + (j+1)*x_inc - Link_randomDouble0_1()*x_inc;
        setAttribute((GraphObject*) v, "x", x);
        setAttribute((GraphObject*) v, "y", y);
    }
}
